export default abstract class Layer {
    id: string;
    minZoom: number;
    maxZoom: number;
    zoomOffset: number;
    constructor(id: string);
    setId(id: string): void;
    getId(): string;
    setMinZoom(minZoom: number): void;
    setMaxZoom(maxZoom: number): void;
    setZoomOffset(zoomOffset: number): void;
    abstract setZIndex(zIndex: number): any;
}
