var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
import AbstractLeafletLayer from "./AbstractLeafletLayer";
import wmtsLayer from "../../control/layer-plugin/L.tileLayer.wmts";
var LeafletWmtsLayer = (function (_super) {
    __extends(LeafletWmtsLayer, _super);
    function LeafletWmtsLayer() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    LeafletWmtsLayer.prototype.getLayer = function () {
        if (this.layer) {
            return this.layer;
        }
        var _url = this.url;
        if (_url.includes("?request=GetCapabilities")) {
            _url = _url.replace("?request=GetCapabilities", "");
        }
        if (_url.includes("&request=GetCapabilities")) {
            _url = _url.replace("&request=GetCapabilities", "");
        }
        this.url = _url;
        var obj = Object.assign(this.getLayerOptions(), this.wmtsOptions);
        var wmtsOptions = Object.fromEntries(Object.entries(obj).filter(function (_a) {
            var _ = _a[0], value = _a[1];
            return value !== undefined;
        }));
        this.layer = wmtsLayer(this.url, wmtsOptions);
        return this.layer;
    };
    LeafletWmtsLayer.prototype.setWmtsOptions = function (wmtsOptions) {
        this.wmtsOptions = wmtsOptions;
    };
    LeafletWmtsLayer.prototype.setZIndex = function (zIndex) {
        if (this.layer) {
            this.layer.setZIndex(zIndex);
        }
    };
    return LeafletWmtsLayer;
}(AbstractLeafletLayer));
export default LeafletWmtsLayer;
